//***************************************************
//
//
//***************************************************

class PlayVizController extends xPlayer;

var bool bHasInteraction;
var PlayVizInteraction PVInteraction;

var float ElapsedTime;

var PlayVizReceiveUdpLink UdpLink;
var PlayVizUdpLink SendUdpLink;
var int Port, SendPort;
var int i;

simulated event PostBeginPlay()
{
    super.PostBeginPlay();

    if(PVInteraction == none)
    {
        log("Initialized PlayVizInteraction");
        PVInteraction = PlayVizInteraction(Player.InteractionMaster.AddInteraction("PlayViz.PlayVizInteraction", Player));
        bHasInteraction = true;
    }

    if(UdpLink == none)
    {
        UdpLink = Spawn(class'PlayVizReceiveUdpLink');
        UdpLink.InitUdpLink(Port);
    }
    /*if(SendUdpLink == None)
    {
        SendUdpLink = Spawn(class'PlayVizUdpLink');
        SendUdpLink.InitUdpLink(SendPort);
    }*/
}

function PlayerTick(float DeltaTime)
{
    local Vector PlayerLocation;
    local Rotator PlayerRotate;

    super.PlayerTick(DeltaTime);

    if(PVInteraction == none)
    {
        self.ConsoleCommand("ghost");
        self.ConsoleCommand("loaded");

        PVInteraction = PlayVizInteraction(Player.InteractionMaster.AddInteraction("PlayViz.PlayVizInteraction", Player));
        bHasInteraction = true;
    }
    if(UdpLink == none)
    {
        UdpLink = Spawn(class'PlayVizReceiveUdpLink');
        UdpLink.InitUdpLink(Port);
    }
    if(PVInteraction.bRecordData && SendUdpLink == None)
    {
        SendUdpLink = Spawn(class'PlayVizUdpLink');
        SendUdpLink.InitUdpLink(SendPort);
    }

    if(SendUdpLink != None)
    {
        ElapsedTime += DeltaTime;

        if(ElapsedTime > 0.05)
        {
            if(Pawn != none)
            {
                if(!SendUdpLink.SendText(SendUdpLink.Addr, Pawn.Location@self.Rotation))
                {
                    log("Did not transmit data");
                }
            }
            else
            {
                if(!SendUdpLink.SendText(SendUdpLink.Addr, self.Location@self.Rotation))
                {
                    log("Did not transmit data");
                }
            }

            ElapsedTime -= 0.05;
        }
    }
    if(UdpLink.bSendData)
    {
        PlayerLocation.X = UdpLink.xpos;
        PlayerLocation.Y = UdpLink.ypos;
        PlayerLocation.Z = UdpLink.zpos;
        //log(UdpLink.xpos $ " " $ UdpLink.ypos $ " " $ UdpLink.zpos);
        //log(self.Location.X $ " " $ self.Location.Y $ " " $ self.Location.Z);
        //log(PlayerLocation.X $ " " $ PlayerLocation.Y $ " " $ PlayerLocation.Z);
        if(Pawn != None)
        {
            Pawn.SetLocation(PlayerLocation);
        }
        else
        {
            SetLocation(PlayerLocation);
        }

        PlayerRotate.Pitch = UdpLink.xrot;
        PlayerRotate.Yaw = UdpLink.yrot;
        PlayerRotate.Roll = UdpLink.zrot;
        SetRotation(PlayerRotate);

        UdpLink.bSendData = false;
    }
}

defaultproperties
{
    ElapsedTime=0.0
    bHasInteraction=false

    Port=13777
    SendPort=13888
    i = 0;
}
