import processing.core.*; import hypermedia.*; import proxml.*; import java.util.ArrayList; import java.util.List; import java.util.StringTokenizer; import java.io.File; import java.util.Hashtable; import java.util.Enumeration; import javax.swing.*; import javax.swing.filechooser.*; import hypermedia.net.*; import hypermedia.picoip.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class PlayVizProgram extends PApplet {






// Importing libraries needed for open/saving of files







// Variables used to control the PlayViz main program
Timeline timeline;
Reel currentReel;
Frame currentFrame, nextFrame;
InfoBar infobar;
ToolBar toolbar;
Frame copiedFrame;
ArrayList copiedFrames = new ArrayList();
ArrayList exportFrames = new ArrayList();

// Variables used for control functions
boolean play, record;
int scrollpos, vscrollpos, timepos, oldtimepos;
float zoom;
float playtime, playstart, starttimepos;
boolean recorddata;
int playtimes = 0;

// Mouse control variables
boolean mouseReleased, rmousePressed, rmouseReleased, mouseDragged;
int mouseXDragged;

// Key control variables
boolean keyControl, keyShift, keyLeft, keyRight, keyUp, keyDown, keyC, keyV, keyX, keyZ;
//boolean key0, key1, key2, key3, key4, key5, key6, key7, key8, key9;

// Scrollbar variables
float SCROLL_MULTIPLIER = 9.33f;
float VSCROLL_MULTIPLIER = 25;

// Font variable
PFont pvFont;

// UDP and XML stuff for Unreal connection
UDP udp;
final int UDP_SEND = 13777;
final int UDP_RECEIVE = 13888;

// XML variables for loading and saving PlayViz XML files
XMLInOut xmlIO;
XMLElement xmlTimeline;
XMLElement xmlReel;
XMLElement xmlFrame;

// Variables needed for file open/saving methods
JFileChooser chooser;
PVFileFilter fileFilter;

public void setup()
{
  // Set up basic Processing variables
  size(900, 250);
  smooth();
  frameRate(15);

  // Load gui elements
  pvFont = loadFont("Verdana-10.vlw");
  textFont(pvFont);
  infobar = new InfoBar();
  toolbar = new ToolBar();

  // Initialize interface and UDP libraries
  // Arbitrarily choose a UDP port number
  udp = new UDP(this, UDP_RECEIVE);

  // Start listening for UDP stream
  udp.listen(true);
  udp.broadcast(true);

  timeline = new Timeline();
  timeline.addReel();
  currentReel = timeline.getReel(0);
  currentFrame = null;

  xmlIO = new XMLInOut(this);
  /*try
   {
   xmlIO.loadElement("test.xml");
   }
   catch(Exception e){ println("Could not find XML file"); }*/

  // Initialize PlayViz variables to their default values
  play = record = false;
  scrollpos = vscrollpos = timepos = 0;
  oldtimepos = -1;
  zoom = 2.0f;
  playstart = -1;
  playtime = starttimepos = 0.0f;

  // Initialize all the mouse variables to false to begin the program
  mouseReleased = rmousePressed = rmouseReleased = false;

  // Setup Java open/save dialog pop-ups
  chooser = new JFileChooser(new File("./data"));
  fileFilter = new PVFileFilter();
  fileFilter.addExtension("xml");
  fileFilter.setDescription("XML Files");
  chooser.setFileFilter(fileFilter);
}

// The draw function is equivalent to a "tick" in Processing, there
// should be approximately 30 ticks a second based upon the initial
// framerate setup
public void draw()
{
  background(250);

  checkButtons(); // Check if buttons have been pressed each tick

  // If copy command is inputted, then copy the current frame into
  // the copyFrame variable to be stored until future use
  if(keyC)
  {
    if(currentFrame != null)
    {
      if(copiedFrames != null){ 
        copiedFrames.clear();
      }
      copiedFrames.add(currentFrame.copy());
      println(copiedFrames.size());
    }
  }
  //CHECK THIS CONDITION
  if(keyV)
  {
    int tempTime = timepos;
    if(currentReel != null && copiedFrames.size() > 0)
    {
      //trouble
      int i = 0;
      while(i < copiedFrames.size()){
        infobar.message("Copying frame at " + tempTime/zoom);
        float tempPos = tempTime/zoom;
        //if(copiedFrames.get(i) != null){
        Frame temp3 = ((Frame)copiedFrames.get(i)).copy();
        temp3.frameStart = tempPos;
        copiedFrames.set(i, temp3);
        //}  
        Frame temp4 = currentReel.getFrameAt(tempPos);
        if(copiedFrames.size() > 1){
          if(temp4 != null){
            /*if(i == (copiedFrames.size - 1)){
             copiedFrames = (Frame[])expand(copiedFrames, copiedFrames.length+1);
             }*/
            //copiedFrames.add(currentReel.getFrameAt(tempPos).copy());
            println("Did This");
          }
        }
        currentReel.addFrame((Frame)copiedFrames.get(i));
        if(((Frame)copiedFrames.get(i)).getLength() > 0.5f){
          tempTime += ((Frame)copiedFrames.get(i)).getLength() + (((Frame)copiedFrames.get(i)).getLength() - 1);
        }
        tempTime++;
        i++;
      }
    }
  }
  if(keyX)
  {
    if(currentFrame != null)
    {
      currentFrame.interpolate = !currentFrame.interpolate;
    }
  }
  if(keyZ)
  {
    if(currentFrame != null)
    {
      currentFrame.show = !currentFrame.show;
    }
  }
  if(keyLeft && scrollpos > 0)
  {
    timeline.hs.spos -= SCROLL_MULTIPLIER;
    timeline.hs.newspos = timeline.hs.spos;
  }
  if(keyRight)
  {
    timeline.hs.spos += SCROLL_MULTIPLIER;
    timeline.hs.newspos = timeline.hs.spos;
  }

  if(keyUp && vscrollpos > 0)
  {
    timeline.vs.spos -= VSCROLL_MULTIPLIER;
    timeline.vs.newspos = timeline.vs.spos;
  }
  if(keyDown)
  {
    timeline.vs.spos += VSCROLL_MULTIPLIER;
    timeline.vs.newspos = timeline.vs.spos;
  }

  if(keyPressed && (key == '0')){
    if(timeline.numReels() >= 1){
      currentReel = timeline.getReel(0);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  } 

  if(keyPressed && (key == '1')){
    if(timeline.numReels() >= 2){
      currentReel = timeline.getReel(1);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  if(keyPressed && (key == '2')){
    if(timeline.numReels() >= 3){
      currentReel = timeline.getReel(2);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  if(keyPressed && (key == '3')){
    if(timeline.numReels() >= 4){
      currentReel = timeline.getReel(3);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  if(keyPressed && (key == '4')){
    if(timeline.numReels() >= 5){
      currentReel = timeline.getReel(4);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  if(keyPressed && (key == '5')){
    if(timeline.numReels() >= 6){
      currentReel = timeline.getReel(5);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  if(keyPressed && (key == '6')){
    if(timeline.numReels() >= 7){
      currentReel = timeline.getReel(6);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  if(keyPressed && (key == '7')){
    if(timeline.numReels() >= 8){
      currentReel = timeline.getReel(7);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  if(keyPressed && (key == '8')){
    if(timeline.numReels() >= 9){
      currentReel = timeline.getReel(8);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  if(keyPressed && (key == '9')){
    if(timeline.numReels() >= 10){
      currentReel = timeline.getReel(9);
      if(currentReel.hasFrames()){
        currentFrame = currentReel.getFrame(0);
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);      
        //play = false;
        //record = false;
      }
    }
  }

  toolbar.update();

  if(timeline != null)
  {
    // Explaining how the scroll bar works
    // The scrollbar value from getPos() gives the basic pixel position of the scrollbar.
    // Thus since we've set up the reelname overflow to be about 100 and the center of the
    // horizontal scroll button is about 2 so we subtract 102 to get to around 0 rounded.
    // The max value then is whatever the length of the program is, in this case 900, but 
    // with the subtracted constant value we get approximately between 0 - 800. We then divide
    // this amount by sum constant and then change cast it to an int to get our scrollpos
    // variable. The same principle applies for the vertical scrollbar.

    int adjustScrollpos = PApplet.parseInt((timeline.maxTime - (width - Reel.REELNAME_OVERFLOW - 15)/(15*zoom))*zoom) + 3;
    if(adjustScrollpos < 1)
    {
      adjustScrollpos = 1;
    }
    SCROLL_MULTIPLIER = (width - Reel.REELNAME_OVERFLOW)/adjustScrollpos;

    // Update position based on scrollbar
    scrollpos = (int)((timeline.hs.getPos() - Reel.REELNAME_OVERFLOW - 2)/SCROLL_MULTIPLIER); // Ranges from 0 - 75
    vscrollpos = abs((int)((timeline.vs.getPos() + 67)/20));

    //println(timeline.hs.getPos() + " " + scrollpos);
    //println(timeline.vs.getPos() + " " + vscrollpos);

    timeline.update();
    timeline.draw();
  }

  infobar.draw();
  toolbar.draw();

  if(udp.isClosed())
  {
    println("Cannot receive messages");
  }

  // If the current mode is play then we need to start automatically
  // incrementing the time position marker
  if(play && timeline != null)
  {
    if(playstart < 0)
    {
      playstart = millis()/1000.0f;
      starttimepos = timepos/zoom;
    }
    playtime = millis()/1000.0f - playstart + starttimepos;

    if(currentFrame != null)
    {
      if(currentFrame.show && currentFrame.interpolate &&
        playtime >= currentFrame.showStart() + currentFrame.getStartTime() &&
        playtime < currentFrame.showStart() + currentFrame.showLength() + currentFrame.getStartTime())
      {
        if (nextFrame != null)
        {

          //___________________________________________________________________________________________________________________________________
          //Grab the values of the next frame positions/rotations.
          //x = vertical rotation (problematic)
          //y = horizontal rotation
          float x1, x2, y1, y2;
          float pos1, pos2, pos3;

          x1 = currentFrame.getRotation().x();
          y1 = currentFrame.getRotation().y();
          x2 = nextFrame.getRotation().x();
          y2 = nextFrame.getRotation().y();

          pos1 = currentFrame.getPosition().x();
          pos2 = currentFrame.getPosition().y();
          pos3 = currentFrame.getPosition().z();

          float dxp, dyp, dzp, dxr, dyr;

          dxp = (nextFrame.getPosition().x() - currentFrame.getPosition().x())/currentFrame.getLength()*(playtime - currentFrame.getStartTime());
          dyp = (nextFrame.getPosition().y() - currentFrame.getPosition().y())/currentFrame.getLength()*(playtime - currentFrame.getStartTime());
          dzp = (nextFrame.getPosition().z() - currentFrame.getPosition().z())/currentFrame.getLength()*(playtime - currentFrame.getStartTime());
          dxr = (nextFrame.getRotation().x() - currentFrame.getRotation().x())/currentFrame.getLength()*(playtime - currentFrame.getStartTime());
          dyr = (nextFrame.getRotation().y() - currentFrame.getRotation().y())/currentFrame.getLength()*(playtime - currentFrame.getStartTime());


          /*if( ){
           x2 = nextFrame.getRotation().x();
           
           if(x2 >= 65536){
           x2 = x2 - 65535;
           }             
           else if(x2 <= 0){
           x2 = 65535 + x2;
           }
           //currentFrame = currentReel.getNextFrame(currentFrame);
           }*/
          if( (x2 - x1) >= 30000 || (x2 - x1) <=-30000 ||
            (y2 - y1) >= 30000 || (y2 - y1) <=-30000) {
            int i = 0;
            while(i < 5){             
              pos1 = currentFrame.getPosition().x() + dxp/5;
              pos2 = currentFrame.getPosition().y() + dyp/5;
              pos3 = currentFrame.getPosition().z() + dzp/5;
              y2 = currentFrame.getRotation().y() + dyr/5;
              x2 = currentFrame.getRotation().x() + dxr/5;
              //x2 += dxr/5;

              if(x2 >= 65536){
                x2 = 1;
                String interpolateString = (pos1 + "," + pos2 + "," + pos3 + " " + x2 + "," + y2 + "," + 0); 
                x2 = nextFrame.getPosition().x() / 2;
              }             
              else if(x2 <= 0){
                x2 = 65535;
                String interpolateString = (pos1 + "," + pos2 + "," + pos3 + " " + x2 + "," + y2 + "," + 0); 
                x2 =  x2 + ((nextFrame.getPosition().x() + 65535) / 2);
              }
              if(y2 >= 65536){
                y2 = y2 - 65535;
              }             
              else if(y2 <= 0){
                y2 = 65535 + y2;
              }

              String interpolateString = (pos1 + "," + pos2 + "," + pos3 + " " + x2 + "," + y2 + "," + 0); 

              udp.send(interpolateString, "localhost", UDP_SEND);
              i++;
              int j = 0;
              //while(j<1000000){j++;}
            }
          }

          else {
            String interpolateString = ((nextFrame.getPosition().x() - currentFrame.getPosition().x())/currentFrame.getLength()*(playtime - currentFrame.getStartTime()) + currentFrame.getPosition().x()) + "," +
              ((nextFrame.getPosition().y() - currentFrame.getPosition().y())/currentFrame.getLength()*(playtime - currentFrame.getStartTime()) + currentFrame.getPosition().y()) + "," +
              ((nextFrame.getPosition().z() - currentFrame.getPosition().z())/currentFrame.getLength()*(playtime - currentFrame.getStartTime()) + currentFrame.getPosition().z()) + " " +
              ((nextFrame.getRotation().x() - currentFrame.getRotation().x())/currentFrame.getLength()*(playtime - currentFrame.getStartTime()) + currentFrame.getRotation().x()) + "," +
              ((nextFrame.getRotation().y() - currentFrame.getRotation().y())/currentFrame.getLength()*(playtime - currentFrame.getStartTime()) + currentFrame.getRotation().y()) + "," + 0;
            udp.send(interpolateString, "localhost", UDP_SEND);         
          }

          //println("Sent: " + currentFrame.getString());
          //  currentFrame = nextFrame;
          // nextFrame = currentReel.getNextFrame(currentFrame);
          //___________________________________________________________________________________________________________________________________
        }
        else
        {
          println("Sent: " + currentFrame.getString());
          udp.send(currentFrame.getString(), "localhost", UDP_SEND);
          exportFrames.add(currentFrame.copy());
          }
        }
      else if(currentFrame.show &&
        playtime >= currentFrame.showStart() + currentFrame.getStartTime() &&
        playtime < currentFrame.showStart() + currentFrame.showLength() + currentFrame.getStartTime())
      {
        println("Sent: " + currentFrame.getString());
        udp.send(currentFrame.getString(), "localhost", UDP_SEND);
        exportFrames.add(currentFrame.copy());
        }
      else if(playtime < currentFrame.showStart() + currentFrame.getStartTime() ||
        playtime >= currentFrame.showStart() + currentFrame.showLength() + currentFrame.getStartTime())
      {
        // Find new current frame
        for(int i = 0; i < timeline.numReels(); i++)
        {
          Reel tempReel = timeline.getReel(i);
          currentFrame = tempReel.getFrameAt(playtime);
          if(currentFrame != null)
          {
            if(currentFrame.show && 
              playtime >= currentFrame.showStart() + currentFrame.getStartTime() &&
              playtime < currentFrame.showStart() + currentFrame.showLength() + currentFrame.getStartTime())
            {
              println("Sent: " + currentFrame.getString());
              udp.send(currentFrame.getString(), "localhost", UDP_SEND);
              exportFrames.add(currentFrame.copy());
                currentReel = tempReel;
              break;
            }
            currentFrame = null;
          }
        }

        if(currentFrame != null)
        {
          if(currentFrame.interpolate)
          {
            nextFrame = currentReel.getNextFrame(currentFrame);
          }
        }
      }
    }

    //here
    else
    {
      for(int i = 0; i < timeline.numReels(); i++)
      {
        Reel tempReel = timeline.getReel(i);
        currentFrame = tempReel.getFrameAt(playtime);
        if(currentFrame != null)
        {
          if(currentFrame.show && 
            playtime >= currentFrame.showStart() + currentFrame.getStartTime() &&
            playtime < currentFrame.showStart() + currentFrame.showLength() + currentFrame.getStartTime())
          {
            println("Sent: " + currentFrame.getString());
            exportFrames.add(currentFrame.copy());
              udp.send(currentFrame.getString(), "localhost", UDP_SEND);
            break;
          }
          currentFrame = null;          
        }
      }

      if(currentFrame != null)
      {
        if(currentFrame.interpolate)
        {
          nextFrame = currentReel.getNextFrame(currentFrame);
        }
      }
    }

    timepos = (int)(playtime*zoom);

    // If the time position marker goes off the screen, automatically
    // scroll a whole screen forward so the marker is always on-screen
    if(timepos - scrollpos > 44)
    {
      timeline.hs.spos += 44*SCROLL_MULTIPLIER;
      timeline.hs.newspos = timeline.hs.spos;
    }
  }
  // If record is true, also do some basic timekeeping
  else if(record)
  {
    if(playstart < 0)
    {
      playstart = millis()/1000.0f;
      starttimepos = timepos/zoom;
      recorddata = true;
    }
    playtime = millis()/1000.0f - playstart + starttimepos;

    if(timepos != (int)playtime*zoom)
    {
      recorddata = true;
    }

    timepos = (int)(playtime*zoom);

    // If the time position marker goes off the screen, automatically
    // scroll a whole screen forward so the marker is always on-screen
    if(timepos - scrollpos > 44)
    {
      timeline.hs.spos += 44*SCROLL_MULTIPLIER;
      timeline.hs.newspos = timeline.hs.spos;
    }
  }

  // Reset all the necessary control variables at the end of each tick,
  // including all the mouse and key variables not handled by Processing.
  // The CTRL boolean variable is not resetted because we want to recognize
  // when it is pressed and NOT when it is released.
  if(!mousePressed && !rmousePressed)
  {
    mouseDragged = false;
    mouseXDragged = 0;
  }

  if(mouseDragged)
  {
    mouseXDragged += mouseX - pmouseX;
  }

  // This handles the dragging interface for changing the shown portion of
  // a frame. It calculates where the relative start and end points of the
  // highlighted portions are, takes all the frames selected within that scope,
  // and adjusts the shown portion accordingly.

  //CHECK HERE AT KEY UNTIL copiedFrames = (Frame[])temp;
  if(rmouseReleased && mouseXDragged > 5)
  {
    if(currentReel != null)
    {
      int pos1 = oldtimepos;
      int pos2 = scrollpos + (mouseX - currentReel.REELNAME_OVERFLOW)/15;

      List frames = currentReel.getFramesAt(pos1, pos2);
      //println(pos1/zoom + " " + pos2/zoom);

      for(int i = 0; i < frames.size(); i++)
      {
        Frame f = (Frame)frames.get(i);

        if(!keyControl && !keyShift)
        {
          f.show = true;
        }

        if(pos1/zoom != f.getStartTime() + f.getLength() && pos2/zoom != f.getStartTime())
        {
          if(keyShift)
          {
            currentReel.removeFrame(f);
          }
          else if(keyControl)
          {
            f.show = !f.show;
          }
          else if(key == 'a' || key == 'A')
          {
            if(i == 1){ 
              copiedFrames.clear();
            }
            copiedFrames.add(f.copy());

          }

          else if(key == 's' || key == 'S')
          {
            if(i == 1){ 
              copiedFrames.clear();
            }
            copiedFrames.add(f.copy());
            currentReel.removeFrame(f);
          }

          else if(key == 'd' || key == 'D')
          {
            if(f.frameStart >= pos1/zoom)
            {
              f.showStart = 0.0f;
            }
            else
            {
              f.showStart = pos1/zoom - f.getStartTime();
            }

            //println(f.showStart());

            if(f.getStartTime() + f.getLength() <= pos2/zoom)
            {
              f.showLength = f.getLength() - f.showStart();
            }
            else
            {
              f.showLength = pos2/zoom - f.getStartTime() - f.showStart();
            }
          }
        }
      }
      infobar.message("Copy Size: " + copiedFrames.size());
      //copiedFrames = (Frame[])temp;
      oldtimepos = -1;
    }
  }

  mouseReleased = false;
  rmouseReleased = false;
  keyC = keyV = keyX = keyZ = false;

  // If none of the mouse buttons are being pressed then logically the
  // right mouse button is not pressed
  if(!mousePressed)
  {
    rmousePressed = false;
  }
}

public void receive(byte[] data)
{
  //data = contract(data, data.length - 2);
  String message = new String(data);

  println(message);

  if(record && currentReel != null)
  {
    if(message.equals("end_socket"))
    {
    }
    else if(recorddata)
    {
      StringTokenizer st = new StringTokenizer(message);

      if(st.countTokens() == 2)
      {
        StringTokenizer sl = new StringTokenizer(st.nextToken(), ",");
        StringTokenizer sr = new StringTokenizer(st.nextToken(), ",");

        if(sl.countTokens() == 3 && sr.countTokens() == 3)
        {
          // Assign the position and rotation vectors to some temporary variables
          float posX = Float.valueOf(sl.nextToken()).floatValue();
          float posY = Float.valueOf(sl.nextToken()).floatValue();
          float posZ = Float.valueOf(sl.nextToken()).floatValue();
          float rotX = Float.valueOf(sr.nextToken()).floatValue();
          float rotY = Float.valueOf(sr.nextToken()).floatValue();
          float rotZ = Float.valueOf(sr.nextToken()).floatValue();

          //println(posX + "," + posY + "," + posZ + " " + rotX + "," + rotY + "," + rotZ);

          // If the current frame is not null, then we should check for same basic things
          if(currentFrame != null)
          {

            println(currentFrame.getPosition().x() + " " +
              currentFrame.getPosition().y() + " " +
              currentFrame.getPosition().z() + " " +
              currentFrame.getRotation().x() + " " +
              currentFrame.getRotation().y() + " " +
              currentFrame.getRotation().z());

            if(currentFrame.getPosition().x() == posX &&
              currentFrame.getPosition().y() == posY &&
              currentFrame.getPosition().z() == posZ &&
              currentFrame.getRotation().x() == rotX &&
              currentFrame.getRotation().y() == rotY &&
              currentFrame.getRotation().z() == rotZ)
            {
              currentFrame.frameLength = timepos/zoom - currentFrame.frameStart + 1.0f/zoom;
              currentFrame.showLength = currentFrame.frameLength;
            }
            else if(currentFrame.frameStart != timepos/zoom)
            {
              currentReel.addFrame(posX, posY, posZ, rotX, rotY, rotZ, 1.0f/zoom);
            }
          }
          // Otherwise (i.e. this is the first frame added)
          else
          {
            currentReel.addFrame(posX, posY, posZ, rotX, rotY, rotZ, 1.0f/zoom);
          }
        }
      }
      recorddata = false;
    }
  }
}

public void checkButtons()
{
  // Button presses
  if(toolbar.recordbutton.pressed)
  {
    record = true;

    toolbar.recordbutton.locked = true;

    currentFrame = null;

    infobar.message("Recording started");
  }

  if(toolbar.playbutton.pressed)
  {
    play = true;

    toolbar.playbutton.locked = true;

    infobar.message("Playing recording");
    exportFrames.clear();
  }

  if(toolbar.stopbutton.pressed)
  {
    if(record)
    {
      infobar.message("Recording halted");
    }
    else if(play)
    {
      infobar.message("Playback halted");
      
    }

    toolbar.recordbutton.locked = false;
    toolbar.playbutton.locked = false;
    toolbar.stopbutton.locked = false;

    // Reset play variables
    playtime = 0.0f;
    playstart = -1.0f;

    record = false;
    play = false;
  }

  if(toolbar.newbutton.pressed)
  {
    timeline = new Timeline();
    timeline.addReel();
    currentReel = timeline.getCurrentReel();

    infobar.message("New timeline created!");
  }

  if(toolbar.savebutton.pressed)
  {
    int returnVal = chooser.showSaveDialog(this);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      File savedFile = chooser.getSelectedFile();
      buildXMLTree();
      try
      {
        xmlIO.saveElement(xmlTimeline, savedFile.getName() + ".xml");

        infobar.message("File saved as " + savedFile.getName() + ".xml");
      }
      catch(Exception e) { 
        println("Could not save file"); 
      }
    }
  }

  if(toolbar.exportbutton.pressed)
  {
    playToMaya();
  }

  if(toolbar.loadbutton.pressed)
  {
    int returnVal = chooser.showOpenDialog(this);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      try
      {
        //println(chooser.getSelectedFile().getName());
        xmlIO.loadElement(chooser.getSelectedFile().getName());

        infobar.message(chooser.getSelectedFile().getName() + " successfully opened");
      }
      catch(Exception e) { 
        println("Could not find XML file"); 
      }
    }
  }

  if(toolbar.addbutton.pressed)
  {
    timeline.addReel();
    currentReel = timeline.getCurrentReel();

    infobar.message("New reel added!");
  }

  if(toolbar.delbutton.pressed)
  {
    if(currentReel != null)
    {
      timeline.removeReel(currentReel);

      infobar.message(currentReel.name + " deleted from timeline"); 

      currentReel = null;
    }
  }

  if(toolbar.zoominbutton.pressed)
  {
    if(zoom < 32)
    {
      zoom *= 2;
      infobar.message("Zoomed in");
    }
    else
    {
      infobar.message("Cannot zoom in further");
    }    
  }

  if(toolbar.zoomoutbutton.pressed)
  {
    zoom /= 2;

    infobar.message("Zoomed out");
  }
}

public void mousePressed()
{
  if(mouseButton == RIGHT)
  {
    rmousePressed = true;
  }
}

public void mouseReleased()
{
  if(mouseButton == LEFT)
  {
    mouseReleased = true;
  }
  else if(mouseButton == RIGHT)
  {
    rmouseReleased = true;
  }

  if(mouseButton == LEFT && currentReel != null)
  {
    if(currentReel.over)
    {
      currentReel.pressed = true;
      currentReel.t_pressed = 0;
    }
  }
}

public void mouseDragged()
{
  mouseDragged = true;
}

// Handle boolean key control variables not built into processing
public void keyPressed()
{
  if(key == CODED)
  {
    if(keyCode == CONTROL)
    {
      keyControl = true;
    }
    if(keyCode == SHIFT)
    {
      keyShift = true;
    }
    if(keyCode == LEFT)
    {
      keyLeft = true;
    }
    if(keyCode == RIGHT)
    {
      keyRight = true;
    }
    if(keyCode == UP)
    {
      keyUp = true;
    }
    if(keyCode == DOWN)
    {
      keyDown = true;
    }
  }
}

public void keyReleased()
{
  if(key == CODED)
  {
    if(keyCode == CONTROL)
    {
      keyControl = false;
    }
    if(keyCode == SHIFT)
    {
      keyShift = false;
    }
    if(keyCode == LEFT)
    {
      keyLeft = false;
    }
    if(keyCode == RIGHT)
    {
      keyRight = false;
    }
    if(keyCode == UP)
    {
      keyUp = false;
    }
    if(keyCode == DOWN)
    {
      keyDown = false;
    }
  }
  // In PlayViz the delete command should delete the current camera
  // movement occupying a time slice, thus if the currentReel is not
  // null and the currentFrame is not null then remove the currentFrame
  // from the currentReel (i.e. delete it)
  else if(key == DELETE)
  {
    if(currentReel != null && currentFrame != null)
    {
      currentReel.frames.remove(currentFrame);
    }
  }
  else if(key == 'Z' || key == 'z')
  {
    keyZ = true;
  }
  else if(key == 'X' || key == 'x')
  {
    keyX = true;
  }
  else if(key == 'C' || key == 'c')
  {
    keyC = true;
  }
  else if(key == 'V' || key == 'v')
  {
    keyV = true;
  }
}

class PVFileFilter extends javax.swing.filechooser.FileFilter
{ 
  final private static String TYPE_UNKNOWN = "Type Unknown";
  final private static String HIDDEN_FILE = "Hidden File"; 
  private Hashtable filters = null;
  private String description = null;
  private String fullDescription = null;
  private boolean useExtensionsInDescription = true;
  
  public PVFileFilter() {
    this.filters = new Hashtable();
  }
  
  public PVFileFilter(String extension) {
    this(extension,null);
  }
  
  public PVFileFilter(String extension, String description) {
    this();
    if(extension!=null) addExtension(extension);
      if(description!=null) setDescription(description);
    }
    
  public PVFileFilter(String[] filters) {
    this(filters, null);
  }
    
  public PVFileFilter(String[] filters, String description) {
    this();
    for (int i = 0; i < filters.length; i++) {
      // add filters one by one
      addExtension(filters[i]);
    }
    if(description!=null) setDescription(description);
  }
  
  public boolean accept(File f) {
    if(f != null) {
      if(f.isDirectory()) {
        return true;
      }
      String extension = getExtension(f);
      if(extension != null && filters.get(getExtension(f)) != null) {
        return true;
      };
    }
    return false;
  }
  
  public String getExtension(File f) {
    if(f != null) {
      String filename = f.getName();
      int i = filename.lastIndexOf('.');
      if(i>0 && i<filename.length()-1) {
        return filename.substring(i+1).toLowerCase();
      };
    }
    return null;
  }
  
  public void addExtension(String extension) {
    if(filters == null) {
      filters = new Hashtable(5);
    }
    filters.put(extension.toLowerCase(), this);
    fullDescription = null;
  }
  
  public String getDescription() {
    if(fullDescription == null) {
      if(description == null || isExtensionListInDescription()) {
        fullDescription = description==null ? "(" : description + " (";
        // build the description from the extension list
        Enumeration extensions = filters.keys();
        if(extensions != null) {
          fullDescription += "." + (String) extensions.nextElement();
          while (extensions.hasMoreElements()) {
            fullDescription += ", ." + (String) extensions.nextElement();
          }
        }
        fullDescription += ")";
      } else {
      fullDescription = description;
      }
    }
    return fullDescription;
  }

  public void setDescription(String description) {
    this.description = description;
    fullDescription = null;
  }

  public void setExtensionListInDescription(boolean b) {
    useExtensionsInDescription = b;
    fullDescription = null;
  }

    public boolean isExtensionListInDescription() {
    return useExtensionsInDescription;
  }
}

class ToolBar
{
  PImage logo;
  PImage play, play_over, play_down;
  PImage record, record_over, record_down;
  PImage stop, stop_over, stop_down;
  PImage newb, new_over, new_down;
  PImage saved, save_over, save_down;
  PImage load, load_over, load_down;
  PImage addreel, addreel_over, addreel_down;
  PImage delreel, delreel_over, delreel_down;
  PImage zoomin, zoomin_over, zoomin_down;
  PImage zoomout, zoomout_over, zoomout_down;
  PImage export, export_over, export_down;
  
  ImageButton playbutton, recordbutton, stopbutton;
  ImageButton savebutton, loadbutton, newbutton;
  ImageButton addbutton, delbutton;
  ImageButton zoominbutton, zoomoutbutton;
  ImageButton exportbutton;
  
  public ToolBar()
  {
    logo = loadImage("logo.png");
   
    // Setup toolbar images 
    play = loadImage("button_play.png");
    play_over = loadImage("button_play_over.png");
    play_down = loadImage("button_play_down.png");
    
    record = loadImage("button_record.png");
    record_over = loadImage("button_record_over.png");
    record_down = loadImage("button_record_down.png");
    
    stop = loadImage("button_stop.png");
    stop_over = loadImage("button_stop_over.png");
    stop_down = loadImage("button_stop_down.png");
    
    newb = loadImage("button_new.png");
    new_over = loadImage("button_new_over.png");
    new_down = loadImage("button_new_down.png");
    
    saved = loadImage("button_save.png");
    save_over = loadImage("button_save_over.png");
    save_down = loadImage("button_save_down.png");
    
    load = loadImage("button_load.png");
    load_over = loadImage("button_load_over.png");
    load_down = loadImage("button_load_down.png");
    
    addreel = loadImage("button_add.png");
    addreel_over = loadImage("button_add_over.png");
    addreel_down = loadImage("button_add_down.png");
    
    delreel = loadImage("button_delete.png");
    delreel_over = loadImage("button_delete_over.png");
    delreel_down = loadImage("button_delete_down.png");
    
    zoomin = loadImage("button_zoomin.png");
    zoomin_over = loadImage("button_zoomin_over.png");
    zoomin_down = loadImage("button_zoomin_down.png");
    
    zoomout = loadImage("button_zoomout.png");
    zoomout_over = loadImage("button_zoomout_over.png");
    zoomout_down = loadImage("button_zoomout_down.png");
    
    export = loadImage("button_export.png");
    export_over = loadImage("button_export_over.png");
    export_down = loadImage("button_export_down.png");
    
    // Setup positioning for toolbar
    playbutton = new ImageButton(8, 5, 30, 30, play, play_over, play_down);
    recordbutton = new ImageButton(46, 5, 30, 30, record, record_over, record_down);
    stopbutton = new ImageButton(84, 5, 30, 30, stop, stop_over, stop_down);
    newbutton = new ImageButton(208, 5, 30, 30, newb, new_over, new_down);
    savebutton = new ImageButton(246, 5, 30, 30, saved, save_over, save_down);
    loadbutton = new ImageButton(284, 5, 30, 30, load, load_over, load_down);
    addbutton = new ImageButton(408, 5, 30, 30, addreel, addreel_over, addreel_down);
    delbutton = new ImageButton(448, 5, 30, 30, delreel, delreel_over, delreel_down);
    zoominbutton = new ImageButton(508, 5, 30, 30, zoomin, zoomin_over, zoomin_down);
    zoomoutbutton = new ImageButton(548, 5, 30, 30, zoomout, zoomout_over, zoomout_down);
    exportbutton = new ImageButton(648, 5, 30, 30, export, export_over, export_down);
  }
  
  public void update()
  {
    playbutton.update();
    recordbutton.update();
    stopbutton.update();
    newbutton.update();
    savebutton.update();
    loadbutton.update();
    addbutton.update();
    delbutton.update();
    zoominbutton.update();
    zoomoutbutton.update();
    exportbutton.update();
  }
  
  public void draw()
  {
    noStroke();
    fill(150, 150, 100);
    rect(0, 0, width, 40);
    //fill(230);
    //rect(0, 37, width, 3);
    
    image(logo, width - 110, 7);
    
    playbutton.draw();
    recordbutton.draw();
    stopbutton.draw();
    newbutton.draw();
    savebutton.draw();
    loadbutton.draw();
    addbutton.draw();
    delbutton.draw();
    zoominbutton.draw();
    zoomoutbutton.draw();
    exportbutton.draw();
  }
}

class InfoBar
{
  String info;
  
  public InfoBar()
  {
    info = "";
  }
  
  public void message(String info)
  {
    this.info = info;
  }
  
  public void draw()
  {
    noStroke();
    fill(110, 165, 225);
    rect(0, height - 15, width, height);
    fill(0);
    text(this.info, 5, height - 3);
  }
}

class Scrollbar
{
  int swidth, sheight;    // width and height of bar
  int xpos, ypos;         // x and y position of bar
  float spos, newspos;    // x position of slider
  int sposMin, sposMax;   // max and min values of slider
  int loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;
  
  public Scrollbar(int xp, int yp, int sw, int sh, int l)
  {
    swidth = sw;
    sheight = sh;
    int widthtoheight = sw - sh;
    ratio = (float)sw/(float)widthtoheight;
    xpos = xp;
    ypos = yp - sheight/2;
    spos = xpos;
    newspos = spos;
    sposMin = xpos;
    sposMax = xpos + swidth - sheight;
    loose = l;
  }
  
  public int constrain(int val, int minv, int maxv)
  {
    return min(max(val, minv), maxv);
  }

  public boolean over()
  {
    if(mouseX > xpos && mouseX < xpos+swidth &&
       mouseY > ypos && mouseY < ypos+sheight)
    {
      return true;
    }
    else
    {
      return false;
    }
  }
}

class VScrollbar extends Scrollbar
{ 
  public VScrollbar(int xp, int yp, int sw, int sh, int l)
  {
    super(xp, yp, sw, sh, l);
    
    int widthtoheight = sw - sh;
    ratio = (float)sh/(float)widthtoheight;
    xpos = xp - swidth/2;
    ypos = yp;
    spos = ypos;
    newspos = spos;
    
    sposMin = ypos;
    sposMax = ypos - swidth + sheight;
  }
  
  public void update()
  {
    if(over())
    {
      over = true;
    }
    else
    {
      over = false;
    }
    if(mousePressed && over)
    {
      locked = true;
    }
    if(!mousePressed)
    {
      locked = false;
    }
    if(locked)
    {
      newspos = constrain(mouseY - swidth/2, sposMin, sposMax);
    }
    if(abs(newspos - spos) > 1)
    {
      spos = spos + (newspos-spos)/loose;
    }
  }

  public void draw()
  {
    noStroke();
    fill(255);
    rect(xpos, ypos, swidth, sheight);
    if(over || locked)
    {
      fill(153, 102, 0);
    }
    else
    {
      fill(102, 102, 102);
    }
    rect(xpos, spos, swidth, swidth);
    
    stroke(200);
    line(xpos, ypos, xpos, ypos + sheight);
    line(xpos, ypos + sheight, xpos + swidth, ypos + sheight);
  }

  public float getPos() {
    // convert spos to be values between
    // 0 and the total width of the scrollbar
    return spos * ratio;
  }
}

class HScrollbar extends Scrollbar
{
  public HScrollbar(int xp, int yp, int sw, int sh, int l)
  {
    super(xp, yp, sw, sh, l);
  }

  public void update()
  {
    if(over())
    {
      over = true;
    }
    else
    {
      over = false;
    }
    if(mousePressed && over)
    {
      locked = true;
    }
    if(!mousePressed)
    {
      locked = false;
    }
    if(locked)
    {
      newspos = constrain(mouseX - sheight/2, sposMin, sposMax);
    }
    if(abs(newspos - spos) > 1)
    {
      spos = spos + (newspos - spos)/loose;
    }
  }

  public void draw()
  {
    noStroke();
    fill(255);
    rect(xpos, ypos, swidth, sheight);
    if(over || locked)
    {
      fill(153, 102, 0);
    }
    else
    {
      fill(102, 102, 102);
    }
    rect(spos, ypos, sheight, sheight);
    
    stroke(200);
    line(xpos, ypos, xpos + swidth, ypos);
    line(xpos + swidth, ypos, xpos + swidth, ypos + sheight);
  }

  public float getPos() {
    // convert spos to be values between
    // 0 and the total width of the scrollbar
    return spos * ratio;
  }
}

class Button
{
  int x, y;
  int w, h;
  int basecolor, highlightcolor;
  int currentcolor;
  boolean downed = false;
  boolean over = false;
  boolean pressed = false;
  boolean locked = false;
  
  public void downed()
  {
    if(over && mousePressed)
    {
      downed = true;
    }
  }
  
  public void pressed()
  {
    if(over && mouseReleased && !locked)
    {
      downed = false;
      pressed = true;
    }
    else
    {
      pressed = false;
    }    
  }
  
  public boolean overRect(int x, int y, int width, int height)
  {
    if (mouseX >= x && mouseX <= x+width && 
        mouseY >= y && mouseY <= y+height)
    {
      return true;
    } 
    else
    {
      return false;
    }
  }
}

class ImageButton extends Button 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage currentimage;

  public ImageButton(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    down = idown;
    currentimage = base;
  }
  
  public void update() 
  {
    downed();
    over();
    pressed();
    if(downed)
    {
      currentimage = down;
    }
    else if(pressed || (locked && !over))
    {
      currentimage = down;
    }
    else if(over)
    {
      currentimage = roll;
    }
    else
    {
      currentimage = base;
    }
  }
  
  public void over() 
  {
    if(overRect(x, y, w, h))
    {
      over = true;
    } 
    else
    {
      over = false;
    }
  }
  
  public void draw() 
  {
    image(currentimage, x, y);
  }
}

class Timeline
{
  List reels;
  float max_time;
  HScrollbar hs;
  VScrollbar vs;
  
  boolean over;
  
  float maxTime; // The longest time point for the timeline, used to calculate the horizontal scrollbar
  
  public Timeline()
  {
    reels = new ArrayList();
    max_time = 0;
    
    hs = new HScrollbar(100, height - 23, width - 114, 15, 1);
    vs = new VScrollbar(width - 7, 61, 15, height - 91, 1);
    
    over = false;
    
    maxTime = 0.0f;
  }
  
  public boolean addReel() { return reels.add(new Reel(numReels())); }
  public boolean removeReel(Reel r) { return reels.remove(r); }
  public int numReels() { return reels.size(); }
  public Reel getReel(int i) { return (Reel)reels.get(i); }
  public Reel getCurrentReel() { return this.getReel(this.numReels() - 1); }
  
  public void calculateMaxTime(Frame f)
  {
    if(f.getStartTime() + f.getLength() > maxTime)
    {
      maxTime = f.getStartTime() + f.getLength();
    }
    //println(maxTime);
  }
  
  public void update()
  {
    hs.update();
    vs.update();
    
    if(over())
    {
      over = true;
    }
    else
    {
      over = false;
    }
    if(mousePressed && over)
    {
      timepos = (int)((mouseX - 100)/15) + scrollpos;
      
      if(currentReel != null)
      {
        currentFrame = currentReel.getFrameAt(timepos);
      }
      
      // Write message about current time position clicked
      infobar.message("Time position: " + timepos/zoom);
    }
    
    for(int i = 0; i < reels.size(); i++)
    {
      this.getReel(i).update();
    }
    
  }
  
  public boolean over()
  {
    if(mouseX > 100 && mouseX < width - 15 &&
       mouseY > 40 && mouseY < 60 + numReels()*30)
    {
      return true;
    }
    else
    {
      return false;
    }
  }
  
  public void draw()
  {
    // Draw based on scroll position
    
    // Draw time numbers lines
    noStroke();
    fill(240);
    rect(100, 40, width - 100, 20);
    stroke(0);
    line(100, 40, width, 40);
    line(100, 60, width, 60);
    
    // Write in the time numbers
    for(int i = scrollpos; i < (int)(width - Reel.REELNAME_OVERFLOW)/15 + scrollpos; i++)
    {
      fill(0);
      if(i % 5 == 0)
      {
        //text(i/zoom, 100 + (i - scrollpos)*15, 54);
        
        line(101 + (i - scrollpos)*15, 40, 101 + (i - scrollpos)*15, 43);
        line(101 + (i - scrollpos)*15, 57, 101 + (i - scrollpos)*15, 60);
      }
      
      stroke(0);
      line(100 + (i - scrollpos)*15, 40, 100 + (i - scrollpos)*15, 43);
      line(100 + (i - scrollpos)*15, 57, 100 + (i - scrollpos)*15, 60);
    }  
    
    noStroke();
    fill(255);
    rect(0, 40, 99, height - 55);
    stroke(200);
    line(99, 40, 99, height - 15);
    
    for(int i = vscrollpos; i < reels.size(); i++)
    {
      this.getReel(i).draw();
    }
    
    // Draw time pos
    if(timepos >= scrollpos)
    {
      stroke(255, 100, 100);
      noFill();
      rect(100 + (timepos - scrollpos)*15, 40, 15, 20);
      line(107 + (timepos - scrollpos)*15, 60, 107 + (timepos - scrollpos)*15, 60 + (numReels() - vscrollpos)*30);
    }
    
    hs.draw(); 
    vs.draw();
    
    // Fill in square for scroll bars (aesthetics)
    fill(250);
    rect(width - 14, height - 30, 15, 15);
  }
}

class Reel
{
  List frames;
  String name;

  int position;
  boolean over, selected, pressed;
  boolean overFrameStart, overFrameEnd, overFrameStartLock, overFrameEndLock;
  int t_pressed;

  static final int REELNAME_OVERFLOW = 100;

  public Reel(int position)
  {
    frames = new ArrayList();

    name = "Camera" + position;

    this.position = position;
  }

  // Function for adding a frame to a reel where start time is based upon
  // the current time position on the reel
  public boolean addFrame(double xpos, double ypos, double zpos,
  double xrot, double yrot, double zrot,
  float frameLength)
  {
    return this.addFrame(xpos, ypos, zpos, xrot, yrot, zrot, timepos/zoom, frameLength, true, true, 0.0f, frameLength);
  }

  // Function for adding a frame to a reel when the frame already has a set
  // start time position
  public boolean addFrame(double xpos, double ypos, double zpos,
  double xrot, double yrot, double zrot,
  float frameStart, float frameLength, boolean interpolate,
  boolean show, float showStart, float showLength)
  {
    return this.addFrame(new Frame(new Vector(xpos, ypos, zpos), new Vector(xrot, yrot, zrot), frameStart, frameLength, interpolate, show, showStart, showLength));    
  }

  public boolean addFrame(Frame f)
  {
    currentFrame = f;

    timeline.calculateMaxTime(f);

    return frames.add(currentFrame);
  }

  // Gives the current y position in pixels for the frame, used specifically
  // since this a number commonly used throughout the draw function
  private int ypos() { 
    return 60 + (position - vscrollpos)*30; 
  }

  public boolean hasFrames() { 
    if(frames.size() > 0)
      return true; 
    else
      return false;
  }
  public int numFrames() { 
    return frames.size(); 
  }
  public Frame getFrame(int i) { 
    return (Frame)frames.get(i); 
  }
  public boolean removeFrame(Frame f) { 
    return frames.remove(f); 
  }

  public void update()
  {
    for(int i = 0; i < frames.size(); i++)
    {
      Frame f = getFrame(i);

      if((f.frameStart*zoom >= scrollpos && f.frameStart*zoom <= scrollpos + 25*zoom) ||
        ((f.frameStart + f.frameLength)*zoom >= scrollpos && (f.frameStart + f.frameLength)*zoom <= scrollpos + 25*zoom))
      {
        f.update(REELNAME_OVERFLOW, ypos());
      }
    }

    if(currentReel == this)
    {
      selected = true;
    }  
    else
    {
      selected = false;
    }

    if(over())
    {
      over = true;
    }
    else
    {
      over = false;
    }

    if(mousePressed && over && !pressed && !mouseDragged)
    {
      currentReel = this;
      fill(0,255,255);
    }
    /*else if(mousePressed && over && !pressed && currentReel != this && currentFrame != null)
     {
     currentReel.removeFrame(currentFrame);
     currentReel = this;
     currentReel.addFrame(currentFrame);
     }*/
    else if(rmousePressed && over && oldtimepos < 0)
    {
      oldtimepos = scrollpos + (int)((mouseX - REELNAME_OVERFLOW)/15);
    }
    // If a doubleclick event occurs then if the time slice has some portion of a
    // camera movement (frame) involved then it should trasmit that frame through
    // the UDP protocol
    else if (mousePressed && over && pressed)
    {
      // Doubleclick event
      //currentFrame = getClickedFrame();
      if(currentFrame != null)
      {
        println("Sent: " + currentFrame.getString());

        udp.send(currentFrame.getString(), "localhost", UDP_SEND);
      }

      pressed = false;
    }

    // If the mouse is being dragged by the user and the user is "in control" of the start
    // of a frame (i.e. camera control) then the frame's start time needs to be modified.
    if(overFrameStartLock)
    {
      currentFrame.frameStart = timepos/zoom;
    }
    if(overFrameEndLock)
    {
      if(timepos/zoom - currentFrame.frameStart > 0)
      {
        currentFrame.frameLength = timepos/zoom - currentFrame.frameStart;
      }
    }

    if(mousePressed && overFrameStart && !overFrameStartLock)
    {
      overFrameStartLock = true;
    }
    if(mousePressed && overFrameEnd && !overFrameEndLock)
    {
      overFrameEndLock = true;
    }

    if(!mousePressed || play)
    {
      overFrameStartLock = overFrameEndLock = false;
    }

    if(pressed)
    {
      t_pressed++;
      if(t_pressed > 5)
      {
        pressed = false;
      }
    }
  }

  public List getFramesAt(int pos1, int pos2)
  {
    List f = new ArrayList();
    for(int i = 0; i < numFrames(); i++)
    {
      Frame tempFrame = getFrame(i);
      if(tempFrame.getStartTime()*zoom <= pos2 && (tempFrame.getStartTime() + tempFrame.getLength())*zoom >= pos1)
      {
        f.add(tempFrame);
      }
    }
    return f;
  }

  public List getFramesAt(int pos)
  {
    return this.getFramesAt(pos, pos);
  }

  public Frame getFrameAt(int pos)
  {
    List tempFrames = this.getFramesAt(pos);
    if(tempFrames.size() > 0)
    {
      return (Frame)(tempFrames.remove(tempFrames.size() - 1));
    }
    else
    {
      return null;
    }
  }

  public Frame getFrameAt(float time)
  {
    for(int i = 0; i < numFrames(); i++)
    {
      Frame tempFrame = getFrame(i);
      if(tempFrame.getStartTime() <= time && tempFrame.getStartTime() + tempFrame.getLength() >= time)
      {
        return tempFrame;
      }
    }
    return null;
  }

  public Frame getNextFrame(Frame f)
  {
    Frame next = null;

    for(int i = 0; i < frames.size(); i++)
    {
      Frame temp = getFrame(i);
      if(next != null)
      {
        if(temp.getStartTime() > f.getStartTime() && temp.getStartTime() < next.getStartTime())
        {
          next = temp;
        }
      }
      else if(temp.getStartTime() > f.getStartTime())
      {
        next = temp;
      }
    }

    return next;
  }

  public Frame getPreviousFrame(Frame f)
  {
    Frame previous = null;

    for(int i = 0; i < frames.size(); i++)
    {
      Frame temp = getFrame(i);
      if(previous != null)
      {
        if(temp.getStartTime() < f.getStartTime() && temp.getStartTime() > previous.getStartTime())
        {
          previous = temp;
        }
      }
      else if(temp.getStartTime() < f.getStartTime())
      {
        previous = temp;
      }
    }

    return previous;
  }

  private boolean over()
  {
    if(mouseX > 0 && mouseX < width - 15 &&
      mouseY > ypos() && mouseY < ypos() + 30)
    {
      return true;
    }
    else
    {
      return false;
    }
  }

  public void draw()
  {
    // Timebar
    if(position % 2 == 1)
    {
      noStroke();
      fill(250, 240, 240);
      rect(100, ypos(), width - REELNAME_OVERFLOW, 30);
    }

    // Draw time slices in each reel
    for(int i = scrollpos; i < (int)(width - REELNAME_OVERFLOW)/15 + scrollpos; i++)
    {
      // Darkened bars every 5 seconds
      if(i % (5*zoom) == 0)
      {
        if(position % 2 == 0)
        {
          fill(235);
        }
        else
        {
          fill(240, 230, 230);
        }
        rect(REELNAME_OVERFLOW + (i - scrollpos)*15, ypos(), 15, 30);
      }
      stroke(225);
      line(REELNAME_OVERFLOW + (i - scrollpos)*15, ypos(), REELNAME_OVERFLOW + (i - scrollpos)*15, ypos() + 30);
    }  

    // If mouse is being dragged, highlight
    if((mouseButton == LEFT) && mousePressed && over){
      fill(0, 255, 255);
    }

    if((mouseButton == RIGHT) && mouseDragged && over)
    {
      if(keyControl) // Change control if CTRL held to indicate different kind of selection
      {
        fill(255, 185, 15);
      }
      else if(keyShift)
      {
        fill(255, 0, 0);
      }
      else if(keyPressed && (key == 'a' || key == 'A'))
      {
        fill(0,0,255);
      }
      else if(keyPressed && (key == 's' || key == 'S'))
      {
        fill(255, 255, 0);
      }

      else if(keyPressed && (key == 'd' || key == 'D'))
      {
        fill(255, 255, 0);
      }
      for(int i = oldtimepos; i <= scrollpos + (mouseX - REELNAME_OVERFLOW)/15; i++)
      {
        rect(REELNAME_OVERFLOW + (i - scrollpos)*15, ypos(), 15, 30);
      }
    }


    stroke(0);
    line(REELNAME_OVERFLOW, ypos(), width, ypos());
    line(REELNAME_OVERFLOW, ypos() + 30, width, ypos() + 30);

    // Draw frames here
    // Draw circles indicating frames
    float time_elapsed = 0.0f;    

    for(int i = 0; i < frames.size(); i++)
    {
      Frame f = getFrame(i);

      if((f.frameStart*zoom >= scrollpos && f.frameStart*zoom <= scrollpos + 25*zoom) ||
        ((f.frameStart + f.frameLength)*zoom >= scrollpos && (f.frameStart + f.frameLength)*zoom <= scrollpos + 25*zoom))
      {
        f.draw(REELNAME_OVERFLOW, ypos());
      }
    }

    // Name
    stroke(200);
    line(0, ypos(), REELNAME_OVERFLOW, ypos());
    line(0, ypos() + 30, REELNAME_OVERFLOW, ypos() + 30);
    if(selected)
    {
      fill(200);
    }
    else
    {
      fill(255);
    }
    rect(0, ypos(), REELNAME_OVERFLOW, 30);
    fill(0);
    text(name, 10, ypos() + 20);
  }
}

class Frame
{
  Vector position, rotation;
  float frameStart, frameLength;
  boolean interpolate;
  boolean show;
  float showStart, showLength;
  boolean over, overStart, overEnd, startLock, endLock;

  public Frame(Vector position, Vector rotation, float frameStart, float frameLength, boolean interpolate, boolean show, float showStart, float showLength)
  {
    this.position = position;
    this.rotation = rotation;
    this.frameStart = frameStart;
    this.frameLength = frameLength;
    this.interpolate = interpolate;
    this.show = show;
    this.showStart = showStart;
    this.showLength = showLength;
    this.over = false;
  }

  public float getStartTime() { 
    return this.frameStart; 
  }
  public float getLength() { 
    return this.frameLength; 
  }
  public float showStart() { 
    return this.showStart; 
  }
  public float showLength() { 
    return this.showLength; 
  }
  public Vector getPosition() { 
    return this.position; 
  }
  public Vector getRotation() { 
    return this.rotation; 
  }

  public String getString()
  {
    return (position.x + "," + position.y + "," + position.z + " " + rotation.x + "," + rotation.y + "," + rotation.z);
  }

  public Frame copy()
  {
    return new Frame(this.position.copy(), this.rotation.copy(), this.frameStart, this.frameLength, this.interpolate, this.show, this.showStart, this.showLength);
  }

  public void update(int x, int y)
  {
    this.over(x, y);

    if(overStart && mousePressed && !rmousePressed && !mouseDragged)
    {
      startLock = true;
    }
    if(overEnd && mousePressed && !rmousePressed && !mouseDragged)
    {
      endLock = true;
    }

    if(startLock)
    {
      if((timepos + scrollpos)/zoom >= 0)
      {
        frameStart = (timepos + scrollpos)/zoom;
      }

      /*Frame previous = currentReel.getPreviousFrame(this);
       if(previous != null)
       {
       if(previous.getStartTime() + previous.getLength() > frameStart)
       {
       frameStart = previous.getStartTime() + previous.getLength();
       }
       }*/
    }
    if(endLock)
    {
      if((timepos + scrollpos)/zoom - frameStart >= 1.0f/zoom)
      {
        frameLength = (timepos + scrollpos)/zoom - frameStart;

        Frame next = currentReel.getNextFrame(this);
        if(next != null)
        {
          if(next.getStartTime() < frameStart + frameLength)
          {
            next.frameStart = frameStart + frameLength;
          }
        }
      }
      else
      {
        frameLength = 1.0f/zoom;
      }

      if(showLength > frameLength)
      {
        showLength = frameLength;
      }
    }

    if(!mousePressed)
    {
      startLock = false;
      endLock = false;
    }
  }

  public boolean over(int x, int y)
  {
    if(mouseX > x + 2 + (frameStart*zoom + scrollpos)*15 && mouseX < x + 13 + (frameStart*zoom + scrollpos)*15 &&
      mouseY > y + 5 && mouseY < y + 16)
    {
      overStart = true;
    }
    else
    {
      overStart = false;
    }

    if(mouseX > x + 2 + ((frameStart + frameLength)*zoom + scrollpos)*15 && mouseX < x + 13 + ((frameStart + frameLength)*zoom + scrollpos)*15 &&
      mouseY > y + 17 && mouseY < y + 28)
    {
      overEnd = true;
    }
    else
    {
      overEnd = false;
    }

    return false;
  }

  public void draw(int x, int y)
  {    
    // Draw the orange outline indicating "shown" portion
    if(this.show)
    {
      noStroke();
      fill(255, 170, 10);
      if(showStart < frameLength/2)
      {
        if(showLength + showStart >= frameLength/2)
        {
          rect(x + 8 + ((showStart + frameStart)*zoom - scrollpos)*15, y + 9, (frameLength/2 - showStart)*zoom*15, 3);
        }
        else
        {
          rect(x + 8 + ((showStart + frameStart)*zoom - scrollpos)*15, y + 9, (showLength)*zoom*15, 3);
        }
      }
      if(showStart <= frameLength/2 && showLength + showStart >= frameLength/2)
      {
        rect(x + 7 + ((frameStart + frameLength/2)*zoom - scrollpos)*15, y + 9, 3, 13);
      }
      if(showLength + showStart > frameLength/2)
      {
        if(showStart < frameLength/2)
        {
          rect(x + 8 + ((frameStart + frameLength/2)*zoom - scrollpos)*15, y + 20, (showLength + showStart - frameLength/2)*zoom*15, 3);
        }
        else
        {
          rect(x + 8 + ((frameStart + showStart)*zoom - scrollpos)*15, y + 20, (showLength)*zoom*15, 3);
        }
      }
    }

    // Connecting lines
    strokeWeight(1);
    stroke(175);
    line(x + 8 + (frameStart*zoom - scrollpos)*15, y + 11, x + 8 + ((frameStart + frameLength/2)*zoom - scrollpos)*15, y + 11);
    line(x + 8 + ((frameStart + frameLength/2)*zoom - scrollpos)*15, y + 11, x + 8 + ((frameStart + frameLength/2)*zoom - scrollpos)*15, y + 22);
    line(x + 8 + ((frameStart + frameLength/2)*zoom - scrollpos)*15, y + 22, x + 2 + ((frameStart + frameLength)*zoom - scrollpos)*15, y + 22);

    // Circles
    strokeWeight(1);
    if(show && showStart == 0.0f)
    {
      fill(255, 170, 10);
      stroke(255, 170, 10);
      ellipse(x + 8 + (frameStart*zoom - scrollpos)*15, y + 10, 11, 11);
    }
    fill(0);
    stroke(0);
    ellipse(x + 8 + (frameStart*zoom - scrollpos)*15, y + 10, 9, 9);
    noFill();
    if(show && showLength - showStart == frameLength)
    {
      fill(255, 170, 10);
      stroke(255, 170, 10);
      if(interpolate)
      {
        ellipse(x + 8 + ((frameStart + frameLength)*zoom - scrollpos)*15, y + 22, 11, 11);
      }
      else
      {
        rect(x + 3 + ((frameStart + frameLength)*zoom - scrollpos)*15, y + 17, 11, 11);
      }
    }
    fill(255);
    stroke(0);
    if(interpolate)
    {
      ellipse(x + 8 + ((frameStart + frameLength)*zoom - scrollpos)*15, y + 22, 9, 9);    
    }
    else
    {
      rect(x + 4 + ((frameStart + frameLength)*zoom - scrollpos)*15, y + 18, 9, 9); 
    }
  }
}

class Vector
{
  public double x, y, z;

  public Vector(double x, double y, double z)
  {
    this.x = x;
    this.y = y;
    this.z = z;
  }

  public Vector copy()
  {
    return new Vector(x, y, z);
  }

  public float x() { 
    return (float)x; 
  }
  public float y() { 
    return (float)y; 
  }
  public float z() { 
    return (float)z; 
  }
}

// Load xml file
public void xmlEvent(XMLElement element)
{
  xmlTimeline = element;

  if(xmlTimeline != null)
  {
    timeline = new Timeline();

    // Add reels
    for(int i = 0; i < xmlTimeline.countChildren(); i++)
    {
      xmlReel = xmlTimeline.getChild(i);
      timeline.addReel();
      currentReel = timeline.getCurrentReel();

      //currentReel.setStart(xmlReel.getFloatAttribute("starttime"));

      for(int j = 0; j < xmlReel.countChildren(); j++)
      {
        XMLElement frame = xmlReel.getChild(j);
        XMLElement position = frame.getChild(0);
        XMLElement rotation = frame.getChild(1);

        boolean interpolate, show;
        if(frame.getAttribute("interpolate").equals("true"))
        {
          interpolate = true;
        }
        else
        {
          interpolate = false;
        }
        if(frame.getAttribute("show").equals("true"))
        {
          show = true;
        }
        else
        {
          show = false;
        }

        currentReel.addFrame(Double.valueOf(position.getAttribute("x")).doubleValue(), Double.valueOf(position.getAttribute("y")).doubleValue(), Double.valueOf(position.getAttribute("z")).doubleValue(),
        Double.valueOf(rotation.getAttribute("x")).doubleValue(), Double.valueOf(rotation.getAttribute("y")).doubleValue(), Double.valueOf(rotation.getAttribute("z")).doubleValue(),
        Float.valueOf(frame.getAttribute("starttime")).floatValue(), Float.valueOf(frame.getAttribute("length")).floatValue(), interpolate,
        show, Float.valueOf(frame.getAttribute("showstart")).floatValue(), Float.valueOf(frame.getAttribute("showlength")).floatValue());
      }
    }
  }
  else
  {
    println("Cannot find current XML timeline");
  }
}

public void buildXMLTree()
{
  xmlTimeline = new XMLElement("timeline");

  if(timeline != null)
  {
    for(int i = 0; i < timeline.numReels(); i++)
    {
      Reel tempReel = timeline.getReel(i);
      xmlReel = new XMLElement("reel");

      for(int j = 0; j < tempReel.numFrames(); j ++)
      {
        Frame tempFrame = tempReel.getFrame(j);

        xmlFrame = new XMLElement("frame");
        xmlFrame.addAttribute("starttime", tempFrame.getStartTime());
        xmlFrame.addAttribute("length", tempFrame.getLength());
        xmlFrame.addAttribute("showstart", tempFrame.showStart());
        xmlFrame.addAttribute("showlength", tempFrame.showLength());
        if(tempFrame.show)
        {
          xmlFrame.addAttribute("show", "true");
        }
        else
        {
          xmlFrame.addAttribute("show", "false");
        }
        if(tempFrame.interpolate)
        {
          xmlFrame.addAttribute("interpolate", "true");
        }
        else
        {
          xmlFrame.addAttribute("interpolate", "false");
        }

        XMLElement tempPosition = new XMLElement("position");
        tempPosition.addAttribute("x", tempFrame.getPosition().x());
        tempPosition.addAttribute("y", tempFrame.getPosition().y());
        tempPosition.addAttribute("z", tempFrame.getPosition().z());

        XMLElement tempRotation = new XMLElement("rotation");
        tempRotation.addAttribute("x", tempFrame.getRotation().x());
        tempRotation.addAttribute("y", tempFrame.getRotation().y());
        tempRotation.addAttribute("z", tempFrame.getRotation().z());

        xmlFrame.addChild(tempPosition);
        xmlFrame.addChild(tempRotation);

        xmlReel.addChild(xmlFrame);
      }

      xmlTimeline.addChild(xmlReel);
    }
  }
}

public void playToMaya()
{

  if(exportFrames.size() > 0){

    String lines[] = loadStrings("maya.txt");

    PrintWriter output;
    int s = second();
    int m = minute();
    int h = hour();
    
    int d = day();
    int mt = month();
    int y = year();
    
    String filename = "Exports\\PlayViz Camera.ma";
    output = createWriter(filename);

    int maximum = 0;

    String xVals = "1 " + ((Frame)exportFrames.get(0)).getPosition().x();
    String yVals = "1 " + ((Frame)exportFrames.get(0)).getPosition().y();
    String zVals = "1 " + ((Frame)exportFrames.get(0)).getPosition().z();
    String pVals = "1 " + (((Frame)exportFrames.get(0)).getRotation().x() * 0.005493f);
    String wVals = "1 " + (((Frame)exportFrames.get(0)).getRotation().y() * 0.005493f);
    String rVals = "1 " + (((Frame)exportFrames.get(0)).getRotation().z() * 0.005493f);
    String keyFrames = "1 1";
    int esize = 1;
    String kot = "" + 5;

    for(int i = 1; i < exportFrames.size(); i++){
      if(((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) != ((int)(((Frame)exportFrames.get(i-1)).getStartTime()*10))){
        //Visiblity
        keyFrames += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " 1";

        //Position
        xVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getPosition().x());
        yVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getPosition().y());
        zVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getPosition().z());

        //Rotation
        pVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getRotation().x() * 0.005493f);
        wVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getRotation().y() * 0.005493f);
        rVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getRotation().z() * 0.005493f);

        //kot Ints
        kot += " " + 5;
        maximum = ((int)((Frame)exportFrames.get(i)).getStartTime()*10) + ((int)((Frame)exportFrames.get(i)).getLength()*10);
        esize++;
      }
    }
    //start LN 84

    lines[1] = "//Name: PlayViz Camera.ma";
    lines[2] = "//Last modified: Mon, Dec 03, 2007 05:07:18 PM";
    lines[84] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + keyFrames + ";";
    lines[85] = "\tsetAttr -s " + esize + " \".kot[0:" + (esize-1) + "]\"  " + kot + ";";
    lines[89] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + xVals + ";";
    lines[93] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + yVals + ";";
    lines[97] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + zVals + ";";
    lines[101] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + pVals + ";";
    lines[105] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + wVals + ";";
    lines[109] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + rVals + ";";
    lines[113] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + keyFrames + ";";
    lines[117] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + keyFrames + ";";
    lines[121] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + keyFrames + ";";
    lines[170] = "\tsetAttr \".b\" -type \"string\" \"playbackOptions -min 1 -max " + maximum + " -ast 1 -aet " + maximum + "\";";
    lines[173] = "setAttr \".o\" " + 1 + ";";
    lines[209] = "// End of PlayViz Camera.ma";

    for (int k=0; k < lines.length; k++){
      output.println(lines[k]); // Write the coordinate to the file
    }

    output.flush(); // Writes the remaining data to the file
    output.close(); // Finishes the file
    infobar.message("File Saved at " + filename); 
  }

  else{ 
    infobar.message("Play the entire timeline and then export"); 
  }
}





  static public void main(String args[]) {     PApplet.main(new String[] { "PlayVizProgram" });  }}