class ToolBar
{
  PImage logo;
  PImage play, play_over, play_down;
  PImage record, record_over, record_down;
  PImage stop, stop_over, stop_down;
  PImage newb, new_over, new_down;
  PImage saved, save_over, save_down;
  PImage load, load_over, load_down;
  PImage addreel, addreel_over, addreel_down;
  PImage delreel, delreel_over, delreel_down;
  PImage zoomin, zoomin_over, zoomin_down;
  PImage zoomout, zoomout_over, zoomout_down;
  PImage export, export_over, export_down;
  
  ImageButton playbutton, recordbutton, stopbutton;
  ImageButton savebutton, loadbutton, newbutton;
  ImageButton addbutton, delbutton;
  ImageButton zoominbutton, zoomoutbutton;
  ImageButton exportbutton;
  
  public ToolBar()
  {
    logo = loadImage("logo.png");
   
    // Setup toolbar images 
    play = loadImage("button_play.png");
    play_over = loadImage("button_play_over.png");
    play_down = loadImage("button_play_down.png");
    
    record = loadImage("button_record.png");
    record_over = loadImage("button_record_over.png");
    record_down = loadImage("button_record_down.png");
    
    stop = loadImage("button_stop.png");
    stop_over = loadImage("button_stop_over.png");
    stop_down = loadImage("button_stop_down.png");
    
    newb = loadImage("button_new.png");
    new_over = loadImage("button_new_over.png");
    new_down = loadImage("button_new_down.png");
    
    saved = loadImage("button_save.png");
    save_over = loadImage("button_save_over.png");
    save_down = loadImage("button_save_down.png");
    
    load = loadImage("button_load.png");
    load_over = loadImage("button_load_over.png");
    load_down = loadImage("button_load_down.png");
    
    addreel = loadImage("button_add.png");
    addreel_over = loadImage("button_add_over.png");
    addreel_down = loadImage("button_add_down.png");
    
    delreel = loadImage("button_delete.png");
    delreel_over = loadImage("button_delete_over.png");
    delreel_down = loadImage("button_delete_down.png");
    
    zoomin = loadImage("button_zoomin.png");
    zoomin_over = loadImage("button_zoomin_over.png");
    zoomin_down = loadImage("button_zoomin_down.png");
    
    zoomout = loadImage("button_zoomout.png");
    zoomout_over = loadImage("button_zoomout_over.png");
    zoomout_down = loadImage("button_zoomout_down.png");
    
    export = loadImage("button_export.png");
    export_over = loadImage("button_export_over.png");
    export_down = loadImage("button_export_down.png");
    
    // Setup positioning for toolbar
    playbutton = new ImageButton(8, 5, 30, 30, play, play_over, play_down);
    recordbutton = new ImageButton(46, 5, 30, 30, record, record_over, record_down);
    stopbutton = new ImageButton(84, 5, 30, 30, stop, stop_over, stop_down);
    newbutton = new ImageButton(208, 5, 30, 30, newb, new_over, new_down);
    savebutton = new ImageButton(246, 5, 30, 30, saved, save_over, save_down);
    loadbutton = new ImageButton(284, 5, 30, 30, load, load_over, load_down);
    addbutton = new ImageButton(408, 5, 30, 30, addreel, addreel_over, addreel_down);
    delbutton = new ImageButton(448, 5, 30, 30, delreel, delreel_over, delreel_down);
    zoominbutton = new ImageButton(508, 5, 30, 30, zoomin, zoomin_over, zoomin_down);
    zoomoutbutton = new ImageButton(548, 5, 30, 30, zoomout, zoomout_over, zoomout_down);
    exportbutton = new ImageButton(648, 5, 30, 30, export, export_over, export_down);
  }
  
  public void update()
  {
    playbutton.update();
    recordbutton.update();
    stopbutton.update();
    newbutton.update();
    savebutton.update();
    loadbutton.update();
    addbutton.update();
    delbutton.update();
    zoominbutton.update();
    zoomoutbutton.update();
    exportbutton.update();
  }
  
  public void draw()
  {
    noStroke();
    fill(150, 150, 100);
    rect(0, 0, width, 40);
    //fill(230);
    //rect(0, 37, width, 3);
    
    image(logo, width - 110, 7);
    
    playbutton.draw();
    recordbutton.draw();
    stopbutton.draw();
    newbutton.draw();
    savebutton.draw();
    loadbutton.draw();
    addbutton.draw();
    delbutton.draw();
    zoominbutton.draw();
    zoomoutbutton.draw();
    exportbutton.draw();
  }
}

class InfoBar
{
  String info;
  
  public InfoBar()
  {
    info = "";
  }
  
  public void message(String info)
  {
    this.info = info;
  }
  
  public void draw()
  {
    noStroke();
    fill(110, 165, 225);
    rect(0, height - 15, width, height);
    fill(0);
    text(this.info, 5, height - 3);
  }
}

class Scrollbar
{
  int swidth, sheight;    // width and height of bar
  int xpos, ypos;         // x and y position of bar
  float spos, newspos;    // x position of slider
  int sposMin, sposMax;   // max and min values of slider
  int loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;
  
  public Scrollbar(int xp, int yp, int sw, int sh, int l)
  {
    swidth = sw;
    sheight = sh;
    int widthtoheight = sw - sh;
    ratio = (float)sw/(float)widthtoheight;
    xpos = xp;
    ypos = yp - sheight/2;
    spos = xpos;
    newspos = spos;
    sposMin = xpos;
    sposMax = xpos + swidth - sheight;
    loose = l;
  }
  
  int constrain(int val, int minv, int maxv)
  {
    return min(max(val, minv), maxv);
  }

  boolean over()
  {
    if(mouseX > xpos && mouseX < xpos+swidth &&
       mouseY > ypos && mouseY < ypos+sheight)
    {
      return true;
    }
    else
    {
      return false;
    }
  }
}

class VScrollbar extends Scrollbar
{ 
  public VScrollbar(int xp, int yp, int sw, int sh, int l)
  {
    super(xp, yp, sw, sh, l);
    
    int widthtoheight = sw - sh;
    ratio = (float)sh/(float)widthtoheight;
    xpos = xp - swidth/2;
    ypos = yp;
    spos = ypos;
    newspos = spos;
    
    sposMin = ypos;
    sposMax = ypos - swidth + sheight;
  }
  
  void update()
  {
    if(over())
    {
      over = true;
    }
    else
    {
      over = false;
    }
    if(mousePressed && over)
    {
      locked = true;
    }
    if(!mousePressed)
    {
      locked = false;
    }
    if(locked)
    {
      newspos = constrain(mouseY - swidth/2, sposMin, sposMax);
    }
    if(abs(newspos - spos) > 1)
    {
      spos = spos + (newspos-spos)/loose;
    }
  }

  void draw()
  {
    noStroke();
    fill(255);
    rect(xpos, ypos, swidth, sheight);
    if(over || locked)
    {
      fill(153, 102, 0);
    }
    else
    {
      fill(102, 102, 102);
    }
    rect(xpos, spos, swidth, swidth);
    
    stroke(200);
    line(xpos, ypos, xpos, ypos + sheight);
    line(xpos, ypos + sheight, xpos + swidth, ypos + sheight);
  }

  float getPos() {
    // convert spos to be values between
    // 0 and the total width of the scrollbar
    return spos * ratio;
  }
}

class HScrollbar extends Scrollbar
{
  public HScrollbar(int xp, int yp, int sw, int sh, int l)
  {
    super(xp, yp, sw, sh, l);
  }

  void update()
  {
    if(over())
    {
      over = true;
    }
    else
    {
      over = false;
    }
    if(mousePressed && over)
    {
      locked = true;
    }
    if(!mousePressed)
    {
      locked = false;
    }
    if(locked)
    {
      newspos = constrain(mouseX - sheight/2, sposMin, sposMax);
    }
    if(abs(newspos - spos) > 1)
    {
      spos = spos + (newspos - spos)/loose;
    }
  }

  void draw()
  {
    noStroke();
    fill(255);
    rect(xpos, ypos, swidth, sheight);
    if(over || locked)
    {
      fill(153, 102, 0);
    }
    else
    {
      fill(102, 102, 102);
    }
    rect(spos, ypos, sheight, sheight);
    
    stroke(200);
    line(xpos, ypos, xpos + swidth, ypos);
    line(xpos + swidth, ypos, xpos + swidth, ypos + sheight);
  }

  float getPos() {
    // convert spos to be values between
    // 0 and the total width of the scrollbar
    return spos * ratio;
  }
}

class Button
{
  int x, y;
  int w, h;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean downed = false;
  boolean over = false;
  boolean pressed = false;
  boolean locked = false;
  
  public void downed()
  {
    if(over && mousePressed)
    {
      downed = true;
    }
  }
  
  public void pressed()
  {
    if(over && mouseReleased && !locked)
    {
      downed = false;
      pressed = true;
    }
    else
    {
      pressed = false;
    }    
  }
  
  public boolean overRect(int x, int y, int width, int height)
  {
    if (mouseX >= x && mouseX <= x+width && 
        mouseY >= y && mouseY <= y+height)
    {
      return true;
    } 
    else
    {
      return false;
    }
  }
}

class ImageButton extends Button 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage currentimage;

  public ImageButton(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    down = idown;
    currentimage = base;
  }
  
  public void update() 
  {
    downed();
    over();
    pressed();
    if(downed)
    {
      currentimage = down;
    }
    else if(pressed || (locked && !over))
    {
      currentimage = down;
    }
    else if(over)
    {
      currentimage = roll;
    }
    else
    {
      currentimage = base;
    }
  }
  
  void over() 
  {
    if(overRect(x, y, w, h))
    {
      over = true;
    } 
    else
    {
      over = false;
    }
  }
  
  public void draw() 
  {
    image(currentimage, x, y);
  }
}
