class Timeline
{
  List reels;
  float max_time;
  HScrollbar hs;
  VScrollbar vs;
  
  boolean over;
  
  float maxTime; // The longest time point for the timeline, used to calculate the horizontal scrollbar
  
  public Timeline()
  {
    reels = new ArrayList();
    max_time = 0;
    
    hs = new HScrollbar(100, height - 23, width - 114, 15, 1);
    vs = new VScrollbar(width - 7, 61, 15, height - 91, 1);
    
    over = false;
    
    maxTime = 0.0;
  }
  
  public boolean addReel() { return reels.add(new Reel(numReels())); }
  public boolean removeReel(Reel r) { return reels.remove(r); }
  public int numReels() { return reels.size(); }
  public Reel getReel(int i) { return (Reel)reels.get(i); }
  public Reel getCurrentReel() { return this.getReel(this.numReels() - 1); }
  
  void calculateMaxTime(Frame f)
  {
    if(f.getStartTime() + f.getLength() > maxTime)
    {
      maxTime = f.getStartTime() + f.getLength();
    }
    //println(maxTime);
  }
  
  public void update()
  {
    hs.update();
    vs.update();
    
    if(over())
    {
      over = true;
    }
    else
    {
      over = false;
    }
    if(mousePressed && over)
    {
      timepos = (int)((mouseX - 100)/15) + scrollpos;
      
      if(currentReel != null)
      {
        currentFrame = currentReel.getFrameAt(timepos);
      }
      
      // Write message about current time position clicked
      infobar.message("Time position: " + timepos/zoom);
    }
    
    for(int i = 0; i < reels.size(); i++)
    {
      this.getReel(i).update();
    }
    
  }
  
  boolean over()
  {
    if(mouseX > 100 && mouseX < width - 15 &&
       mouseY > 40 && mouseY < 60 + numReels()*30)
    {
      return true;
    }
    else
    {
      return false;
    }
  }
  
  void draw()
  {
    // Draw based on scroll position
    
    // Draw time numbers lines
    noStroke();
    fill(240);
    rect(100, 40, width - 100, 20);
    stroke(0);
    line(100, 40, width, 40);
    line(100, 60, width, 60);
    
    // Write in the time numbers
    for(int i = scrollpos; i < (int)(width - Reel.REELNAME_OVERFLOW)/15 + scrollpos; i++)
    {
      fill(0);
      if(i % 5 == 0)
      {
        //text(i/zoom, 100 + (i - scrollpos)*15, 54);
        
        line(101 + (i - scrollpos)*15, 40, 101 + (i - scrollpos)*15, 43);
        line(101 + (i - scrollpos)*15, 57, 101 + (i - scrollpos)*15, 60);
      }
      
      stroke(0);
      line(100 + (i - scrollpos)*15, 40, 100 + (i - scrollpos)*15, 43);
      line(100 + (i - scrollpos)*15, 57, 100 + (i - scrollpos)*15, 60);
    }  
    
    noStroke();
    fill(255);
    rect(0, 40, 99, height - 55);
    stroke(200);
    line(99, 40, 99, height - 15);
    
    for(int i = vscrollpos; i < reels.size(); i++)
    {
      this.getReel(i).draw();
    }
    
    // Draw time pos
    if(timepos >= scrollpos)
    {
      stroke(255, 100, 100);
      noFill();
      rect(100 + (timepos - scrollpos)*15, 40, 15, 20);
      line(107 + (timepos - scrollpos)*15, 60, 107 + (timepos - scrollpos)*15, 60 + (numReels() - vscrollpos)*30);
    }
    
    hs.draw(); 
    vs.draw();
    
    // Fill in square for scroll bars (aesthetics)
    fill(250);
    rect(width - 14, height - 30, 15, 15);
  }
}
