// Load xml file
void xmlEvent(XMLElement element)
{
  xmlTimeline = element;

  if(xmlTimeline != null)
  {
    timeline = new Timeline();

    // Add reels
    for(int i = 0; i < xmlTimeline.countChildren(); i++)
    {
      xmlReel = xmlTimeline.getChild(i);
      timeline.addReel();
      currentReel = timeline.getCurrentReel();

      //currentReel.setStart(xmlReel.getFloatAttribute("starttime"));

      for(int j = 0; j < xmlReel.countChildren(); j++)
      {
        XMLElement frame = xmlReel.getChild(j);
        XMLElement position = frame.getChild(0);
        XMLElement rotation = frame.getChild(1);

        boolean interpolate, show;
        if(frame.getAttribute("interpolate").equals("true"))
        {
          interpolate = true;
        }
        else
        {
          interpolate = false;
        }
        if(frame.getAttribute("show").equals("true"))
        {
          show = true;
        }
        else
        {
          show = false;
        }

        currentReel.addFrame(Double.valueOf(position.getAttribute("x")).doubleValue(), Double.valueOf(position.getAttribute("y")).doubleValue(), Double.valueOf(position.getAttribute("z")).doubleValue(),
        Double.valueOf(rotation.getAttribute("x")).doubleValue(), Double.valueOf(rotation.getAttribute("y")).doubleValue(), Double.valueOf(rotation.getAttribute("z")).doubleValue(),
        Float.valueOf(frame.getAttribute("starttime")).floatValue(), Float.valueOf(frame.getAttribute("length")).floatValue(), interpolate,
        show, Float.valueOf(frame.getAttribute("showstart")).floatValue(), Float.valueOf(frame.getAttribute("showlength")).floatValue());
      }
    }
  }
  else
  {
    println("Cannot find current XML timeline");
  }
}

void buildXMLTree()
{
  xmlTimeline = new XMLElement("timeline");

  if(timeline != null)
  {
    for(int i = 0; i < timeline.numReels(); i++)
    {
      Reel tempReel = timeline.getReel(i);
      xmlReel = new XMLElement("reel");

      for(int j = 0; j < tempReel.numFrames(); j ++)
      {
        Frame tempFrame = tempReel.getFrame(j);

        xmlFrame = new XMLElement("frame");
        xmlFrame.addAttribute("starttime", tempFrame.getStartTime());
        xmlFrame.addAttribute("length", tempFrame.getLength());
        xmlFrame.addAttribute("showstart", tempFrame.showStart());
        xmlFrame.addAttribute("showlength", tempFrame.showLength());
        if(tempFrame.show)
        {
          xmlFrame.addAttribute("show", "true");
        }
        else
        {
          xmlFrame.addAttribute("show", "false");
        }
        if(tempFrame.interpolate)
        {
          xmlFrame.addAttribute("interpolate", "true");
        }
        else
        {
          xmlFrame.addAttribute("interpolate", "false");
        }

        XMLElement tempPosition = new XMLElement("position");
        tempPosition.addAttribute("x", tempFrame.getPosition().x());
        tempPosition.addAttribute("y", tempFrame.getPosition().y());
        tempPosition.addAttribute("z", tempFrame.getPosition().z());

        XMLElement tempRotation = new XMLElement("rotation");
        tempRotation.addAttribute("x", tempFrame.getRotation().x());
        tempRotation.addAttribute("y", tempFrame.getRotation().y());
        tempRotation.addAttribute("z", tempFrame.getRotation().z());

        xmlFrame.addChild(tempPosition);
        xmlFrame.addChild(tempRotation);

        xmlReel.addChild(xmlFrame);
      }

      xmlTimeline.addChild(xmlReel);
    }
  }
}

void playToMaya()
{

  if(exportFrames.size() > 0){

    String lines[] = loadStrings("maya.txt");

    PrintWriter output;
    int s = second();
    int m = minute();
    int h = hour();
    
    int d = day();
    int mt = month();
    int y = year();
    
    String filename = "Exports\\PlayViz Camera.ma";
    output = createWriter(filename);

    int maximum = 0;

    String xVals = "1 " + ((Frame)exportFrames.get(0)).getPosition().x();
    String yVals = "1 " + ((Frame)exportFrames.get(0)).getPosition().y();
    String zVals = "1 " + ((Frame)exportFrames.get(0)).getPosition().z();
    String pVals = "1 " + (((Frame)exportFrames.get(0)).getRotation().x() * 0.005493);
    String wVals = "1 " + (((Frame)exportFrames.get(0)).getRotation().y() * 0.005493);
    String rVals = "1 " + (((Frame)exportFrames.get(0)).getRotation().z() * 0.005493);
    String keyFrames = "1 1";
    int esize = 1;
    String kot = "" + 5;

    for(int i = 1; i < exportFrames.size(); i++){
      if(((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) != ((int)(((Frame)exportFrames.get(i-1)).getStartTime()*10))){
        //Visiblity
        keyFrames += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " 1";

        //Position
        xVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getPosition().x());
        yVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getPosition().y());
        zVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getPosition().z());

        //Rotation
        pVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getRotation().x() * 0.005493);
        wVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getRotation().y() * 0.005493);
        rVals += " " + ((int)(((Frame)exportFrames.get(i)).getStartTime()*10)) + " " + (((Frame)exportFrames.get(i)).getRotation().z() * 0.005493);

        //kot Ints
        kot += " " + 5;
        maximum = ((int)((Frame)exportFrames.get(i)).getStartTime()*10) + ((int)((Frame)exportFrames.get(i)).getLength()*10);
        esize++;
      }
    }
    //start LN 84

    lines[1] = "//Name: PlayViz Camera.ma";
    lines[2] = "//Last modified: Mon, Dec 03, 2007 05:07:18 PM";
    lines[84] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + keyFrames + ";";
    lines[85] = "\tsetAttr -s " + esize + " \".kot[0:" + (esize-1) + "]\"  " + kot + ";";
    lines[89] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + xVals + ";";
    lines[93] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + yVals + ";";
    lines[97] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + zVals + ";";
    lines[101] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + pVals + ";";
    lines[105] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + wVals + ";";
    lines[109] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + rVals + ";";
    lines[113] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + keyFrames + ";";
    lines[117] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + keyFrames + ";";
    lines[121] = "\tsetAttr -s " + esize + " \".ktv[0:" + (esize-1) + "]\"  " + keyFrames + ";";
    lines[170] = "\tsetAttr \".b\" -type \"string\" \"playbackOptions -min 1 -max " + maximum + " -ast 1 -aet " + maximum + "\";";
    lines[173] = "setAttr \".o\" " + 1 + ";";
    lines[209] = "// End of PlayViz Camera.ma";

    for (int k=0; k < lines.length; k++){
      output.println(lines[k]); // Write the coordinate to the file
    }

    output.flush(); // Writes the remaining data to the file
    output.close(); // Finishes the file
    infobar.message("File Saved at " + filename); 
  }

  else{ 
    infobar.message("Play the entire timeline and then export"); 
  }
}




